Index: /code/trunk/src/core/CoreIncludes.h
===================================================================
--- /code/trunk/src/core/CoreIncludes.h	(revision 1786)
+++ /code/trunk/src/core/CoreIncludes.h	(revision 1787)
@@ -97,5 +97,5 @@
     @param ClassName The name of the class
 */
-#define Class(ClassName) \
+#define GetClassIdentifier(ClassName) \
     ClassIdentifier<ClassName>::getIdentifier()
 
Index: /code/trunk/src/core/XMLPort.cc
===================================================================
--- /code/trunk/src/core/XMLPort.cc	(revision 1786)
+++ /code/trunk/src/core/XMLPort.cc	(revision 1787)
@@ -40,5 +40,5 @@
     bool XMLPortObjectContainer::identifierIsIncludedInLoaderMask(const Identifier* identifier)
     {
-        return ((!this->bApplyLoaderMask_) || identifier->isA(Class(Namespace)) || Loader::currentMask_s.isIncluded(identifier));
+        return ((!this->bApplyLoaderMask_) || identifier->isA(GetClassIdentifier(Namespace)) || Loader::currentMask_s.isIncluded(identifier));
     }
 }
Index: /code/trunk/src/core/XMLPort.h
===================================================================
--- /code/trunk/src/core/XMLPort.h	(revision 1786)
+++ /code/trunk/src/core/XMLPort.h	(revision 1787)
@@ -301,5 +301,5 @@
                                 if (identifier)
                                 {
-                                    if (identifier->isA(Class(O)))
+                                    if (identifier->isA(GetClassIdentifier(O)))
                                     {
                                         if (this->identifierIsIncludedInLoaderMask(identifier))
@@ -333,5 +333,5 @@
                                     else
                                     {
-                                        COUT(2) << ((BaseObject*)object)->getLoaderIndentation() << "Warning: '" << child->Value() << "' is not a '" << Class(O)->getName() << "'." << std::endl;
+                                        COUT(2) << ((BaseObject*)object)->getLoaderIndentation() << "Warning: '" << child->Value() << "' is not a '" << GetClassIdentifier(O)->getName() << "'." << std::endl;
                                     }
                                 }
@@ -346,5 +346,5 @@
                     {
                         COUT(1) << std::endl;
-                        COUT(1) << "An error occurred in XMLPort.h while loading a '" << Class(O)->getName() << "' in '" << this->sectionname_ << "' of '" << this->identifier_->getName() << "' (objectname: " << ((BaseObject*)object)->getName() << ") in " << object->getLevelfile() << ":" << std::endl;
+                        COUT(1) << "An error occurred in XMLPort.h while loading a '" << GetClassIdentifier(O)->getName() << "' in '" << this->sectionname_ << "' of '" << this->identifier_->getName() << "' (objectname: " << ((BaseObject*)object)->getName() << ") in " << object->getLevelfile() << ":" << std::endl;
                         COUT(1) << ex.what() << std::endl;
                     }
Index: /code/trunk/src/orxonox/objects/Model.cc
===================================================================
--- /code/trunk/src/orxonox/objects/Model.cc	(revision 1786)
+++ /code/trunk/src/orxonox/objects/Model.cc	(revision 1787)
@@ -85,5 +85,5 @@
         COUT(4) << "Loader (Model.cc): Created model" << std::endl;
       }
-      if(this->isExactlyA(Class(Model)))
+      if(this->isExactlyA(GetClassIdentifier(Model)))
         setObjectFrequency(300); //sync all 10 seconds (this only applies to asteroids and other isExactlyA(Model)
       return true;
Index: /code/trunk/src/orxonox/objects/Projectile.cc
===================================================================
--- /code/trunk/src/orxonox/objects/Projectile.cc	(revision 1786)
+++ /code/trunk/src/orxonox/objects/Projectile.cc	(revision 1787)
@@ -101,5 +101,5 @@
                 {
                     // hit
-                    if (it->isA(Class(SpaceShipAI)))
+                    if (it->isA(GetClassIdentifier(SpaceShipAI)))
                         ((SpaceShipAI*)(*it))->damage(this->damage_);
                     ParticleSpawner* explosion = new ParticleSpawner(this->explosionTemplateName_, LODParticle::low, 2.0);
Index: /code/trunk/src/orxonox/objects/SpaceShip.cc
===================================================================
--- /code/trunk/src/orxonox/objects/SpaceShip.cc	(revision 1786)
+++ /code/trunk/src/orxonox/objects/SpaceShip.cc	(revision 1787)
@@ -77,5 +77,5 @@
       ObjectList<SpaceShip>::iterator it;
       for(it = ObjectList<SpaceShip>::begin(); it; ++it){
-	assert(it->isA(Class(SpaceShip)));
+	assert(it->isA(GetClassIdentifier(SpaceShip)));
         if( (it)->myShip_ || (network::Host::running() && network::Host::getShipID()==(it)->objectID) ){
 //	  COUT(1) << "^^^^^^^^^^ myShip_:" << *it << " classname: " << (*it)->getIdentifier()->getName() << " objectid: " << (*it)->objectID << std::endl;
@@ -273,5 +273,5 @@
             // END CREATING ADDITIONAL EFFECTS
 
-            if (this->isExactlyA(Class(SpaceShip)))
+            if (this->isExactlyA(GetClassIdentifier(SpaceShip)))
             {
                 // START of testing crosshair
@@ -376,5 +376,5 @@
         COUT(4) << "requesting focus for camera" << std::endl;
         //CameraHandler::getInstance()->requestFocus(cam_);
-        if(this->isExactlyA(Class(SpaceShip))){
+        if(this->isExactlyA(GetClassIdentifier(SpaceShip))){
           getFocus();
           COUT(4) << "getting focus for obj id: " << objectID << std::endl;
@@ -421,5 +421,5 @@
         myShip_=true; //TODO: this is a hack
         SpaceShip::create();
-        /*if (this->isExactlyA(Class(SpaceShip)))
+        /*if (this->isExactlyA(GetClassIdentifier(SpaceShip)))
             getFocus();*/
     }