Index: /code/trunk/src/core/ConfigFileManager.cc
===================================================================
--- /code/trunk/src/core/ConfigFileManager.cc	(revision 1794)
+++ /code/trunk/src/core/ConfigFileManager.cc	(revision 1795)
@@ -73,20 +73,20 @@
     void reloadConfig()
     {
-        ConfigFileManager::getInstance()->load();
+        ConfigFileManager::getInstance().load();
     }
 
     void cleanConfig()
     {
-        ConfigFileManager::getInstance()->clean(false);
+        ConfigFileManager::getInstance().clean(false);
     }
 
     void loadSettings(const std::string& filename)
     {
-        ConfigFileManager::getInstance()->setFile(CFT_Settings, filename, false);
+        ConfigFileManager::getInstance().setFile(CFT_Settings, filename, false);
     }
 
     void loadKeybindings(const std::string& filename)
     {
-        ConfigFileManager::getInstance()->setFile(CFT_Keybindings, filename);
+        ConfigFileManager::getInstance().setFile(CFT_Keybindings, filename);
     }
 
@@ -461,8 +461,8 @@
     }
 
-    ConfigFileManager* ConfigFileManager::getInstance()
+    ConfigFileManager& ConfigFileManager::getInstance()
     {
         static ConfigFileManager instance;
-        return (&instance);
+        return instance;
     }
 
Index: /code/trunk/src/core/ConfigFileManager.h
===================================================================
--- /code/trunk/src/core/ConfigFileManager.h	(revision 1794)
+++ /code/trunk/src/core/ConfigFileManager.h	(revision 1795)
@@ -44,5 +44,7 @@
     {
         CFT_Settings,
-        CFT_Keybindings
+        CFT_Keybindings,
+        CFT_JoyStickCalibration,
+        CFT_KeyNames
     };
 
@@ -256,5 +258,5 @@
     {
         public:
-            static ConfigFileManager* getInstance();
+            static ConfigFileManager& getInstance();
 
             void setFile(ConfigFileType type, const std::string& filename, bool bCreateIfNotExisting = true);
Index: /code/trunk/src/core/ConfigValueContainer.cc
===================================================================
--- /code/trunk/src/core/ConfigValueContainer.cc	(revision 1794)
+++ /code/trunk/src/core/ConfigValueContainer.cc	(revision 1795)
@@ -83,5 +83,5 @@
         for (unsigned int i = 0; i < this->valueVector_.size(); i++)
         {
-            ConfigFileManager::getInstance()->getValue(this->type_, this->sectionname_, this->varname_, i, this->valueVector_[i], this->value_.isType(MT_string));
+            ConfigFileManager::getInstance().getValue(this->type_, this->sectionname_, this->varname_, i, this->valueVector_[i], this->value_.isType(MT_string));
             this->defvalueStringVector_.push_back(this->valueVector_[i]);
         }
@@ -114,5 +114,5 @@
             if (this->tset(input))
             {
-                ConfigFileManager::getInstance()->setValue(this->type_, this->sectionname_, this->varname_, input, this->value_.isType(MT_string));
+                ConfigFileManager::getInstance().setValue(this->type_, this->sectionname_, this->varname_, input, this->value_.isType(MT_string));
                 return true;
             }
@@ -133,5 +133,5 @@
             if (this->tset(index, input))
             {
-                ConfigFileManager::getInstance()->setValue(this->type_, this->sectionname_, this->varname_, index, input, this->value_.isType(MT_string));
+                ConfigFileManager::getInstance().setValue(this->type_, this->sectionname_, this->varname_, index, input, this->value_.isType(MT_string));
                 return true;
             }
@@ -233,6 +233,6 @@
                 this->valueVector_.erase(this->valueVector_.begin() + index);
                 for (unsigned int i = index; i < this->valueVector_.size(); i++)
-                    ConfigFileManager::getInstance()->setValue(this->type_, this->sectionname_, this->varname_, i, this->valueVector_[i], this->value_.isType(MT_string));
-                ConfigFileManager::getInstance()->deleteVectorEntries(this->type_, this->sectionname_, this->varname_, this->valueVector_.size());
+                    ConfigFileManager::getInstance().setValue(this->type_, this->sectionname_, this->varname_, i, this->valueVector_[i], this->value_.isType(MT_string));
+                ConfigFileManager::getInstance().deleteVectorEntries(this->type_, this->sectionname_, this->varname_, this->valueVector_.size());
 
                 return true;
@@ -258,5 +258,5 @@
                 if (!this->set(i, this->defvalueStringVector_[i]))
                     success = false;
-            ConfigFileManager::getInstance()->deleteVectorEntries(this->type_, this->sectionname_, this->varname_, this->defvalueStringVector_.size());
+            ConfigFileManager::getInstance().deleteVectorEntries(this->type_, this->sectionname_, this->varname_, this->defvalueStringVector_.size());
             return success;
         }
@@ -269,17 +269,17 @@
     {
         if (!this->bIsVector_)
-            this->value_ = ConfigFileManager::getInstance()->getValue(this->type_, this->sectionname_, this->varname_, this->defvalueString_, this->value_.isType(MT_string));
+            this->value_ = ConfigFileManager::getInstance().getValue(this->type_, this->sectionname_, this->varname_, this->defvalueString_, this->value_.isType(MT_string));
         else
         {
             this->valueVector_.clear();
-            for (unsigned int i = 0; i < ConfigFileManager::getInstance()->getVectorSize(this->type_, this->sectionname_, this->varname_); i++)
+            for (unsigned int i = 0; i < ConfigFileManager::getInstance().getVectorSize(this->type_, this->sectionname_, this->varname_); i++)
             {
                 if (i < this->defvalueStringVector_.size())
                 {
-                    this->value_ = ConfigFileManager::getInstance()->getValue(this->type_, this->sectionname_, this->varname_, i, this->defvalueStringVector_[i], this->value_.isType(MT_string));
+                    this->value_ = ConfigFileManager::getInstance().getValue(this->type_, this->sectionname_, this->varname_, i, this->defvalueStringVector_[i], this->value_.isType(MT_string));
                 }
                 else
                 {
-                    this->value_ = ConfigFileManager::getInstance()->getValue(this->type_, this->sectionname_, this->varname_, i, MultiType(), this->value_.isType(MT_string));
+                    this->value_ = ConfigFileManager::getInstance().getValue(this->type_, this->sectionname_, this->varname_, i, MultiType(), this->value_.isType(MT_string));
                 }
 
Index: /code/trunk/src/core/input/KeyBinder.cc
===================================================================
--- /code/trunk/src/core/input/KeyBinder.cc	(revision 1794)
+++ /code/trunk/src/core/input/KeyBinder.cc	(revision 1795)
@@ -39,4 +39,5 @@
 #include "core/ConfigValueIncludes.h"
 #include "core/CoreIncludes.h"
+#include "core/ConfigFileManager.h"
 #include "InputCommands.h"
 
@@ -222,10 +223,10 @@
         if (!infile)
         {
-            ConfigFileManager::getInstance()->setFile(CFT_Keybindings, "def_keybindings.ini");
-            ConfigFileManager::getInstance()->save(CFT_Keybindings, "keybindings.ini");
+            ConfigFileManager::getInstance().setFile(CFT_Keybindings, "def_keybindings.ini");
+            ConfigFileManager::getInstance().save(CFT_Keybindings, "keybindings.ini");
         }
         else
             infile.close();
-        ConfigFileManager::getInstance()->setFile(CFT_Keybindings, "keybindings.ini");
+        ConfigFileManager::getInstance().setFile(CFT_Keybindings, "keybindings.ini");
 
         // parse key bindings
Index: /code/trunk/src/orxonox/gamestates/GSRoot.cc
===================================================================
--- /code/trunk/src/orxonox/gamestates/GSRoot.cc	(revision 1794)
+++ /code/trunk/src/orxonox/gamestates/GSRoot.cc	(revision 1795)
@@ -98,7 +98,7 @@
     {
 #if ORXONOX_DEBUG_MODE == 1
-        ConfigFileManager::getInstance()->setFile(CFT_Settings, "orxonox_d.ini");
+        ConfigFileManager::getInstance().setFile(CFT_Settings, "orxonox_d.ini");
 #else
-        ConfigFileManager::getInstance()->setFile(CFT_Settings, "orxonox.ini");
+        ConfigFileManager::getInstance().setFile(CFT_Settings, "orxonox.ini");
 #endif
 