Index: /orxonox/trunk/core/compile
===================================================================
--- /orxonox/trunk/core/compile	(revision 1803)
+++ /orxonox/trunk/core/compile	(revision 1803)
@@ -0,0 +1,12 @@
+
+#gcc -I/usr/local/include -I/GL -I/usr/include -c $argv[1].c
+#echo 'compile finished - linking'
+#gcc -o $argv[1] -o32 gl_test.o \
+#-L/usr/local/lib -L/usr/lib -lglut -L/lib -lm
+
+g++ orxonox.cc -lglut -ffast-math -lMesaGLU -lMesaGL -lm -L/usr/X11/lib \
+-L/usr/X11R6/lib -lX11 -lXext -lXmu -lXt -lXi -lSM -lICE -o orx
+
+
+##end
+
Index: /orxonox/trunk/core/orxonox.cc
===================================================================
--- /orxonox/trunk/core/orxonox.cc	(revision 1803)
+++ /orxonox/trunk/core/orxonox.cc	(revision 1803)
@@ -0,0 +1,54 @@
+/* class definition header */
+#include "orxonox.h"
+
+/* standard headers */
+#include <iostream>
+#include <cstdio>
+
+/* openGL Headers */
+#include <GL/glut.h>
+
+using namespace std;
+
+
+
+Orxonox::Orxonox() {}
+Orxonox::~Orxonox() {}
+
+
+int Orxonox::globalInit(int argc, char** argv) 
+{
+  glutInit(&argc, argv);
+  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
+  glutInitWindowSize(500, 500);
+  glutInitWindowPosition(100, 100);
+  glutCreateWindow("orxOnox");
+  
+  /* window event dispatchers */
+  /*
+    glutDisplayFunc(display);
+    glutReshapeFunc(resphape);
+    glutMainLoop();
+  */
+}
+
+
+int Orxonox::menuInit()
+{
+  glClearColor(0.0, 0.0, 0.0, 0.0);
+  glShadeModel(GL_FLAT);
+}
+
+
+int Orxonox::gameInit() 
+{
+
+}
+
+
+int main( int argc, char** argv ) 
+{  
+  Orxonox orx;
+  orx.globalInit(argc, argv);
+  return 0;
+}
Index: /orxonox/trunk/core/orxonox.h
===================================================================
--- /orxonox/trunk/core/orxonox.h	(revision 1803)
+++ /orxonox/trunk/core/orxonox.h	(revision 1803)
@@ -0,0 +1,16 @@
+#ifndef ORXONOX_H
+#define ORXONOX_H
+
+class Orxonox {
+
+ public:
+  Orxonox();
+  ~Orxonox();
+
+  int globalInit(int argc, char** argv);
+  int menuInit();
+  int gameInit();
+
+};
+
+#endif
Index: /orxonox/trunk/doc/program_examples/c++/README
===================================================================
--- /orxonox/trunk/doc/program_examples/c++/README	(revision 1803)
+++ /orxonox/trunk/doc/program_examples/c++/README	(revision 1803)
@@ -0,0 +1,12 @@
+
+c++ compile guide
+
+to compile the source orxonox:
+
+linux:
+you simply enter following line:
+g++ orxonox.cc -o orxonox
+this will compile orxonox source into a binary called orxonox
+
+
+
Index: /orxonox/trunk/doc/program_examples/c++/orxonox.cc
===================================================================
--- /orxonox/trunk/doc/program_examples/c++/orxonox.cc	(revision 1803)
+++ /orxonox/trunk/doc/program_examples/c++/orxonox.cc	(revision 1803)
@@ -0,0 +1,27 @@
+#include "orxonox.h"
+
+#include <iostream>
+#include <cstdio>
+
+using namespace std;
+
+
+Orxonox::Orxonox() { int x = 1; }
+Orxonox::~Orxonox() { int x = 1; }
+
+
+int Orxonox::getInfo() {  }
+int Orxonox::setInfo() { int z = 1; }
+
+
+
+int main( int argc, char** argv ) {
+  
+  Orxonox orx;
+  orx.getInfo();
+
+  cout << "test" << endl;
+
+  
+  return 0;
+}
Index: /orxonox/trunk/doc/program_examples/c++/orxonox.h
===================================================================
--- /orxonox/trunk/doc/program_examples/c++/orxonox.h	(revision 1803)
+++ /orxonox/trunk/doc/program_examples/c++/orxonox.h	(revision 1803)
@@ -0,0 +1,15 @@
+#ifndef ORXONOX_H
+#define ORXONOX_H
+
+class Orxonox {
+
+ public:
+  Orxonox();
+  ~Orxonox();
+
+  int getInfo();
+  int setInfo();
+
+};
+
+#endif
Index: /orxonox/trunk/doc/program_examples/openGL/compile
===================================================================
--- /orxonox/trunk/doc/program_examples/openGL/compile	(revision 1803)
+++ /orxonox/trunk/doc/program_examples/openGL/compile	(revision 1803)
@@ -0,0 +1,12 @@
+
+#gcc -I/usr/local/include -I/GL -I/usr/include -c $argv[1].c
+#echo 'compile finished - linking'
+#gcc -o $argv[1] -o32 gl_test.o \
+#-L/usr/local/lib -L/usr/lib -lglut -L/lib -lm
+
+gcc cube.c -lglut -ffast-math -lMesaGLU -lMesaGL -lm -L/usr/X11/lib \
+-L/usr/X11R6/lib -lX11 -lXext -lXmu -lXt -lXi -lSM -lICE -o cube
+
+
+##end
+
Index: /orxonox/trunk/doc/program_examples/openGL/cube.c
===================================================================
--- /orxonox/trunk/doc/program_examples/openGL/cube.c	(revision 1803)
+++ /orxonox/trunk/doc/program_examples/openGL/cube.c	(revision 1803)
@@ -0,0 +1,87 @@
+
+
+#include <GL/glut.h>
+
+#include <stdio.h>
+#include <stdlib.h>
+
+
+static float alpha = 0;
+
+void init(void) {
+
+  glClearColor(0.0, 0.0, 0.0, 0.0);
+  glShadeModel(GL_FLAT);
+}
+
+
+void display(void) {
+
+  glClear(GL_COLOR_BUFFER_BIT);
+  glColor3f(1.0, 1.0, 1.0);
+  glLoadIdentity();
+  
+  gluLookAt(5*cos(alpha), 5*sin(alpha), 5.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
+  glScalef(1.0, 2.0, 1.0);
+  glutWireCube(1.0);
+  glFlush();
+}
+
+
+void reshape(int w, int h) {
+
+  glViewport(0, 0, (GLsizei) w, (GLsizei)h);
+  glMatrixMode(GL_PROJECTION);
+  glLoadIdentity();
+  glFrustum(-1.0, 1.0, -1.0, 1.0, 1.5, 20.0);
+  glMatrixMode(GL_MODELVIEW);
+}
+
+
+void spinDisplay( void ) {
+
+  alpha = alpha + 0.01;
+  if (alpha > 360)
+    alpha = 0;
+  glutPostRedisplay();
+}
+
+
+void mouse( int button, int state, int x, int y ) {
+
+  switch( button ) {
+  case GLUT_LEFT_BUTTON:
+    if (state == GLUT_DOWN) {
+      glutIdleFunc(spinDisplay);
+    }
+    break;
+  case GLUT_RIGHT_BUTTON:
+    if (state == GLUT_DOWN) {
+      glutIdleFunc(NULL);
+    }
+    break;
+  default:
+    break;
+  }
+}
+
+
+
+int main(int argc, char** argv) {
+
+  glutInit(&argc, argv);
+  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
+  glutInitWindowSize(500, 500);
+  glutInitWindowPosition(100, 100);
+  glutCreateWindow(argv[0]);
+  init();
+  glutDisplayFunc(display);
+  glutReshapeFunc(reshape);
+  glutMouseFunc(mouse);
+  glutMainLoop();
+
+  return 0;
+}
+
+
+//EOF
Index: /orxonox/trunk/doc/program_examples/openGL/double.c
===================================================================
--- /orxonox/trunk/doc/program_examples/openGL/double.c	(revision 1803)
+++ /orxonox/trunk/doc/program_examples/openGL/double.c	(revision 1803)
@@ -0,0 +1,95 @@
+
+
+#include <stdio.h>
+#include <stdlib.h>
+
+#include <GL/glut.h>
+
+
+static GLfloat spin = 0.0;
+
+void init( void ) {
+
+  glClearColor( 0.0, 1.0, 0.0, 0.0 );
+  glShadeModel( GL_FLAT );
+}
+
+
+void display( void ) {
+
+  glClear( GL_COLOR_BUFFER_BIT );
+  glPushMatrix();
+  glRotatef( spin, 0.0, 0.0, 1.0 );
+  glColor3f( 1.0, 1.0, 1.0 );
+  glRectf( -25.0, -25.0, 25.0, 25.0 );
+  glColor3f(1.0, 0.0, 0.0);
+  glRectf(-5.0, -5.0, 5.0, 5.0);
+
+  glPointSize(4.0);
+  glColor3f(0.0, 0.0, 1.0);
+  glBegin(GL_POINTS);
+  glVertex2f(6.0, 2.0);
+  glVertex2f(15.0, 14.0);
+  glVertex2f(12.0, 20.0);
+  glVertex2f(-3.0, 17.0);
+  glEnd();
+  
+
+  glPopMatrix();
+  glutSwapBuffers();
+}  
+
+
+void spinDisplay( void ) {
+
+  spin = spin + 2.0;
+  if( spin > 360.0 )
+    spin = spin - 360.0;
+  glutPostRedisplay();
+}
+
+
+void reshape(int w, int h) {
+
+  glViewport( 0, 0, (GLsizei) w, (GLsizei) h);
+  glMatrixMode(GL_PROJECTION);
+  glLoadIdentity();
+  glOrtho(-50.0, 50.0, -50.0, 50.0, -1.0, 1.0 );
+  glMatrixMode(GL_MODELVIEW);
+  glLoadIdentity();
+}
+
+
+void mouse( int button, int state, int x, int y ) {
+
+  switch( button ) {
+  case GLUT_LEFT_BUTTON:
+    if (state == GLUT_DOWN)
+      glutIdleFunc(spinDisplay);
+    break;
+  case GLUT_RIGHT_BUTTON:
+    if (state == GLUT_DOWN)
+      glutIdleFunc(NULL);
+    break;
+  default:
+    break;
+  }
+}
+
+
+
+int main( int argc, char** argv ) {
+
+  glutInit(&argc, argv);
+  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
+  glutInitWindowSize(250, 250);
+  glutInitWindowPosition(100, 100);
+  glutCreateWindow("rock-it");
+  init();
+  glutDisplayFunc(display);
+  glutReshapeFunc(reshape);
+  glutMouseFunc(mouse);
+  glutMainLoop();
+
+  return 0;
+}
Index: /orxonox/trunk/doc/program_examples/openGL/gl_test.c
===================================================================
--- /orxonox/trunk/doc/program_examples/openGL/gl_test.c	(revision 1803)
+++ /orxonox/trunk/doc/program_examples/openGL/gl_test.c	(revision 1803)
@@ -0,0 +1,51 @@
+
+
+#include <stdlib.h>
+#include <stdio.h>
+
+#include <GL/glut.h>
+
+
+
+
+void display( void ) {
+
+  glClear( GL_COLOR_BUFFER_BIT );
+  glColor3f( 1.0, 1.0, 1.0 );
+  glBegin( GL_POLYGON );
+  glVertex3f( 0.25, 0.25, 0.0 );
+  glVertex3f( 0.75, 0.25, 0.0 );
+  glVertex3f( 0.75, 0.75, 0.0 );
+  glVertex3f( 0.25, 0.75, 0.0 );
+  glEnd();
+
+  glFlush();
+}
+
+
+
+void init( void ) {
+
+  glClearColor( 0.0, 0.0, 0.0, 0.0 );
+  glMatrixMode( GL_PROJECTION );
+  glLoadIdentity();
+  glOrtho( 0.0, 1.0, 0.0, 1.0, -1.0, 1.0 );
+  
+}
+
+
+
+
+int main( int argc, char** argv ) {
+  
+  glutInit( &argc, argv );
+  glutInitDisplayMode( GLUT_SINGLE | GLUT_RGB );
+  glutInitWindowSize( 250, 250 );
+  glutInitWindowPosition( 100, 100);
+  glutCreateWindow( "hello" );
+  init();
+  glutDisplayFunc( display );
+  glutMainLoop();
+
+  return 0;
+}